!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!		A non-autonomous boundary value problem 
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

 SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!---------- ---- 

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
 DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
 DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
 DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

 DOUBLE PRECISION u1, u2, x, lambda

   lambda = PAR(1)

   u1 = U(1)
   u2 = U(2)
   x  = U(3)

   F(1) = u2 
   F(2) =-lambda*DEXP(x**9*u1) 
   F(3) = 1.d0

 END SUBROUTINE FUNC
!---------------------------------------------------------------------- 

 SUBROUTINE STPNT(NDIM,U,PAR,x)
!---------- ----- 

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM
 DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
 DOUBLE PRECISION, INTENT(IN) :: x

 DOUBLE PRECISION lambda, u1, u2

   lambda = 0.d0
   PAR(1) = lambda

   u1 = 0.d0
   u2 = 0.d0

   U(1) = u1
   U(2) = u2 

! x is the independent variable, with values between 0 and 1
   U(3) = x	

 END SUBROUTINE STPNT
!---------------------------------------------------------------------- 

 SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC) 
!---------- ---- 

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
 DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
 DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
 DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

  FB(1) = U0(1) 
  FB(2) = U1(1) 
  FB(3) = U0(3) 

 END SUBROUTINE BCND
!---------------------------------------------------------------------- 

 SUBROUTINE PVLS(NDIM,U,PAR)
!---------- ----

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM
 DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
 DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
 DOUBLE PRECISION, EXTERNAL :: GETP,GETU2

 DOUBLE PRECISION gamma

!  Set gamma equal to the L2-norm of u1:
   gamma = GETP('NRM',1,U)
   PAR(2) = gamma

 END SUBROUTINE PVLS
!----------------------------------------------------------------------
!---------------------------------------------------------------------- 
 SUBROUTINE ICND
 END SUBROUTINE ICND

 SUBROUTINE FOPT
 END SUBROUTINE FOPT
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
